//E-11 Blaster Rifle by Blastdown
//Reload script by Bushido
//Random bullet spread by Ephialtes

//audio
datablock AudioProfile(BlasterRifleShotSound)
{
   filename    = "./Blasterfire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(blasterrifleHitSound)
{
   filename    = "./blasterHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(BlasterRifleReloadSound)
{
   filename    = "./BlasterReload.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(BlasterRifleShellDebris)
{
	shapeFile = "./BlasterRifle.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//trail
datablock ParticleData(BlasterRifleTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 50;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 0.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 0.0 0.0 1";
	colors[1]	= "1.0 0.0 0.0 1";
	sizes[0]	= 0.15;
	sizes[1]	= 0.25;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(BlasterRifleTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0; 
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 75.0;  
   particles = BlasterRifleTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//muzzle flash effects
datablock ParticleData(BlasterRifleFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BlasterRifleFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BlasterRifleFlashParticle";

   uiName = "BlasterRifle Flash";
};

datablock ParticleData(BlasterRifleExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(BlasterRifleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BlasterRifleExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};


datablock ParticleData(BlasterRifleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 200.0;
	spinRandomMin		= -200.0;
	spinRandomMax		= 200.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BlasterRifleExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BlasterRifleExplosionRingParticle";

   useEmitterColors = true;
   uiName = "BlasterRifle Hit Flash";
};

datablock ExplosionData(BlasterRifleExplosion)
{
   //explosionShape = "";
	soundProfile = blasterrifleHitSound;

   lifeTimeMS = 150;

   particleEmitter = BlasterRifleExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = BlasterRifleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


AddDamageType("BlasterRifle",   '<bitmap:add-ons/Weapon_E11_BlasterRifle/CI_BlasterRifle> %1',    '%2 <bitmap:add-ons/Weapon_E11_BlasterRifle/CI_BlasterRifle> %1',0.2,1);
datablock ProjectileData(BlasterRifleProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 25;
   directDamageType    = $DamageType::BlasterRifle;
   radiusDamageType    = $DamageType::BlasterRifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 3;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 300;
   verticalImpulse	  = 300;
   explosion           = BlasterRifleExplosion;
   particleEmitter     = BlasterRifleTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "BlasterRifle Bullet";
};

//////////
// item //
//////////
datablock ItemData(BlasterRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./blasterrifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Blaster Rifle";
	iconName = "./icon_blasterrifle";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = BlasterRifleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BlasterRifleImage)
{
   // Basic Item properties
   shapeFile = "./blasterrifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = BlasterRifleProjectile;
   projectileType = Projectile;

	casing = BlasterRifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BlasterRifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Ammo1";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

//reload passage!

	stateName[2]                     = "Reload";
	stateAllowImageChange[2]         = true;
	stateSequence[2]                = "Reload";
	stateScript[2]                  = "Reload";
	stateSequence[2]	= "Reload";
	stateTransitionOnTimeout[2]     = "Ready";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]				= 1.20;
	stateSound[2]					= blasterrifleReloadSound;

//ammo passage and firing
//first shot

	stateName[4]                    = "Ammo1";
	stateTransitionOnTimeout[4]     = "Ammo1Ready";
	stateTimeoutValue[4]            = 0.34;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= blasterrifleFlashEmitter;
	stateEmitterTime[4]				= 0.02;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= blasterrifleShotSound;

	stateName[5]                     = "Ammo1Ready";
	stateTransitionOnTriggerDown[5]  = "Ammo2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";

//second shot

	stateName[6]                    = "Ammo2";
	stateTransitionOnTimeout[6]     = "Ammo2Ready";
	stateTimeoutValue[6]            = 0.34;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= blasterrifleFlashEmitter;
	stateEmitterTime[6]				= 0.02;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= blasterrifleShotSound;

	stateName[7]                     = "Ammo2Ready";
	stateTransitionOnTriggerDown[7]  = "Ammo3";
	stateAllowImageChange[7]         = true;
	stateSequence[7]	= "Ready";

//third shot

	stateName[8]                    = "Ammo3";
	stateTransitionOnTimeout[8]     = "Ammo3Ready";
	stateTimeoutValue[8]            = 0.34;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateEmitter[8]					= blasterrifleFlashEmitter;
	stateEmitterTime[8]				= 0.02;
	stateEmitterNode[8]				= "muzzleNode";
	stateSound[8]					= blasterrifleShotSound;

	stateName[9]                     = "Ammo3Ready";
	stateTransitionOnTriggerDown[9]  = "Ammo4";
	stateAllowImageChange[9]         = true;
	stateSequence[9]	= "Ready";

//fourth shot

	stateName[10]                    = "Ammo4";
	stateTransitionOnTimeout[10]     = "Ammo4Ready";
	stateTimeoutValue[10]            = 0.34;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "Fire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateEmitter[10]					= blasterrifleFlashEmitter;
	stateEmitterTime[10]				= 0.02;
	stateEmitterNode[10]				= "muzzleNode";
	stateSound[10]					= blasterrifleShotSound;

	stateName[11]                     = "Ammo4Ready";
	stateTransitionOnTriggerDown[11]  = "Ammo5";
	stateAllowImageChange[11]         = true;
	stateSequence[11]	= "Ready";

//fifth shot

	stateName[12]                    = "Ammo5";
	stateTransitionOnTimeout[12]     = "Ammo5Ready";
	stateTimeoutValue[12]            = 0.34;
	stateFire[12]                    = true;
	stateAllowImageChange[12]        = false;
	stateSequence[12]                = "Fire";
	stateScript[12]                  = "onFire";
	stateWaitForTimeout[12]			= true;
	stateEmitter[12]					= blasterrifleFlashEmitter;
	stateEmitterTime[12]				= 0.02;
	stateEmitterNode[12]				= "muzzleNode";
	stateSound[12]					= blasterrifleShotSound;

	stateName[13]                     = "Ammo5Ready";
	stateTransitionOnTriggerDown[13]  = "Ammo6";
	stateAllowImageChange[13]         = true;
	stateSequence[13]	= "Ready";

//sixth shot

	stateName[14]                    = "Ammo6";
	stateTransitionOnTimeout[14]     = "Ammo6Ready";
	stateTimeoutValue[14]            = 0.34;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateWaitForTimeout[14]			= true;
	stateEmitter[14]					= blasterrifleFlashEmitter;
	stateEmitterTime[14]				= 0.02;
	stateEmitterNode[14]				= "muzzleNode";
	stateSound[14]					= blasterrifleShotSound;

	stateName[15]                     = "Ammo6Ready";
	stateTransitionOnTriggerDown[15]  = "Ammo7";
	stateAllowImageChange[15]         = true;
	stateSequence[15]	= "Ready";

//seventh shot

	stateName[16]                    = "Ammo7";
	stateTransitionOnTimeout[16]     = "Ammo7Ready";
	stateTimeoutValue[16]            = 0.34;
	stateFire[16]                    = true;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateScript[16]                  = "onFire";
	stateWaitForTimeout[16]			= true;
	stateEmitter[16]					= blasterrifleFlashEmitter;
	stateEmitterTime[16]				= 0.02;
	stateEmitterNode[16]				= "muzzleNode";
	stateSound[16]					= blasterrifleShotSound;

	stateName[17]                     = "Ammo7Ready";
	stateTransitionOnTriggerDown[17]  = "Ammo8";
	stateAllowImageChange[17]         = true;
	stateSequence[17]	= "Ready";

//eighth shot and loop back to reload

	stateName[18]                    = "Ammo8";
	stateTransitionOnTimeout[18]     = "Reload";
	stateTimeoutValue[18]            = 0.34;
	stateFire[18]                    = true;
	stateAllowImageChange[18]        = false;
	stateSequence[18]                = "Fire";
	stateScript[18]                  = "onFire";
	stateWaitForTimeout[18]			= true;
	stateEmitter[18]					= blasterrifleFlashEmitter;
	stateEmitterTime[18]				= 0.02;
	stateEmitterNode[18]				= "muzzleNode";
	stateSound[18]					= blasterrifleShotSound;
};

function BlasterRifleImage::onFire(%this,%obj,%slot)
{
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-1"))); // -1 is a variable Knockback force

	%projectile = %this.projectile; //state projectile
	%spread = 0.0005; //Spread value (less makes less spread)
	%shellcount = 1; //Number of shells

	for(%shell=0; %shell<%shellcount; %shell++) //From here on in I have no idea.
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;	
}